declare type OnFulfilled<T, R> = (value: T) => R | PromiseLike<R>;
declare type OnRejected<T = never> = (reason: any) => T | PromiseLike<T>;
declare type GenFunction<T> = (signal: AbortSignal) => Generator<any, T>;
declare type AsyncFunction<R> = (...args: any) => PromiseLike<R>;
declare type AicoOptions = {
    signal?: AbortSignal;
    AbortController?: new () => AbortController;
};
export declare type AsyncResult<F extends AsyncFunction<any>> = F extends AsyncFunction<infer R> ? R : never;
export declare class AbortError extends Error {
    constructor(msg?: string);
    get isAborted(): boolean;
}
export declare class AbortInCoroutines<T> {
    private _ctrl;
    private _promise;
    private _isAborted;
    constructor(gen: GenFunction<T>, { signal: optSig, AbortController }?: AicoOptions);
    then<TR1 = T, TR2 = never>(onfulfilled?: OnFulfilled<T, TR1> | null, onrejected?: OnRejected<TR2> | null): Promise<TR1 | TR2>;
    catch<TR = never>(onrejected?: OnRejected<TR> | null): Promise<T | TR>;
    finally(onfinally?: (() => void) | null): Promise<T>;
    get isAborted(): boolean;
    abort(): void;
}
export declare function aico<T>(genFn: GenFunction<T>, opts?: AicoOptions): AbortInCoroutines<T>;
export default aico;
